## systemd 258.1

=== meson_options.txt ===
# -*- mode: meson -*-
# SPDX-License-Identifier: LGPL-2.1-or-later

option('version-tag', type : 'string',
       description : 'set the extended version string (defaults to project version)')
option('shared-lib-tag', type : 'string',
       description : 'override the private shared library version tag (defaults to project version)')
option('vcs-tag', type : 'boolean', value : true,
       description : 'append current git commit to version output when git information is available')

option('mode', type : 'combo', choices : ['developer', 'release'],
       description : 'autoenable features suitable for systemd development/release builds')

option('split-bin', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'sbin is not a symlink to bin')
option('link-udev-shared', type : 'boolean',
       description : 'link systemd-udevd and its helpers to libsystemd-shared.so')
option('link-executor-shared', type : 'boolean',
       description : 'link systemd-executor to libsystemd-shared.so and libsystemd-core.so')
option('link-systemctl-shared', type: 'boolean',
       description : 'link systemctl against libsystemd-shared.so')
option('link-networkd-shared', type: 'boolean',
       description : 'link systemd-networkd and its helpers to libsystemd-shared.so')
option('link-timesyncd-shared', type: 'boolean',
       description : 'link systemd-timesyncd and its helpers to libsystemd-shared.so')
option('link-journalctl-shared', type: 'boolean',
       description : 'link journalctl against libsystemd-shared.so')
option('link-boot-shared', type: 'boolean',
       description : 'link bootctl and systemd-bless-boot against libsystemd-shared.so')
option('link-portabled-shared', type: 'boolean',
       description : 'link systemd-portabled and its helpers to libsystemd-shared.so')
option('first-boot-full-preset', type: 'boolean', value: false,
       description : 'during first boot, do full preset-all (default will be changed to true later)')

option('static-libsystemd', type : 'combo',
       choices : ['false', 'true', 'pic', 'no-pic'],
       description : 'install a static library for libsystemd')
option('static-libudev', type : 'combo',
       choices : ['false', 'true', 'pic', 'no-pic'],
       description : 'install a static library for libudev')
option('standalone-binaries', type : 'boolean', value : false,
       description : 'also build standalone versions of supported binaries')

option('sysvinit-path', type : 'string', value : '/etc/init.d',
       description : 'the directory where the SysV init scripts are located')
option('sysvrcnd-path', type : 'string', value : '/etc/rc.d',
       description : 'the base directory for SysV rcN.d directories')
option('rc-local', type : 'string', value : '/etc/rc.local',
       description : 'path to SysV rc.local script')
option('initrd', type : 'boolean',
       description : 'install services for use when running systemd in initrd')
option('compat-mutable-uid-boundaries', type : 'boolean', value : false,
       description : 'look at uid boundaries in /etc/login.defs for compatibility')

option('quotaon-path', type : 'string', description : 'path to quotaon')
option('quotacheck-path', type : 'string', description : 'path to quotacheck')
option('kmod-path', type : 'string', description : 'path to kmod')
option('kexec-path', type : 'string', description : 'path to kexec')
option('sulogin-path', type : 'string', description : 'path to sulogin')
option('mount-path', type : 'string', description : 'path to mount')
option('umount-path', type : 'string', description : 'path to umount')
option('loadkeys-path', type : 'string', description : 'path to loadkeys')
option('setfont-path', type : 'string', description : 'path to setfont')
option('nologin-path', type : 'string', description : 'path to nologin')

option('debug-shell', type : 'string', value : '/bin/sh',
       description : 'path to debug shell binary')
option('debug-tty', type : 'string', value : '/dev/tty9',
       description : 'specify the tty device for debug shell')
option('debug-extra', type : 'array', choices : ['hashmap', 'mmap-cache', 'siphash'], value : [],
       description : 'enable extra debugging')
option('memory-accounting-default', type : 'boolean',
       description : 'enable MemoryAccounting= by default')
option('bump-proc-sys-fs-file-max', type : 'boolean',
       description : 'bump /proc/sys/fs/file-max to LONG_MAX')
option('bump-proc-sys-fs-nr-open', type : 'boolean',
       description : 'bump /proc/sys/fs/nr_open to INT_MAX')
option('log-trace', type : 'boolean', value : false,
       description : 'enable low level debug logging')
option('user-path', type : 'string',
       description : '$PATH to use for user sessions')

option('utmp', type : 'boolean',
       description : 'support for utmp/wtmp log handling')
option('hibernate', type : 'boolean',
       description : 'support for hibernation')
option('ldconfig', type : 'boolean',
       description : 'support for dynamic linker cache creation')
option('resolve', type : 'boolean',
       description : 'systemd-resolved stack')
option('efi', type : 'boolean',
       description : 'enable EFI support')
option('tpm', type : 'boolean',
       description : 'TPM should be used to log events and extend the registers')
option('environment-d', type : 'boolean',
       description : 'support for environment.d')
option('binfmt', type : 'boolean',
       description : 'support for custom binary formats')
option('repart', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'install the systemd-repart tool')
option('sysupdate', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'install the systemd-sysupdate tool')
option('sysupdated', type: 'combo', value : 'auto',
       choices : ['auto', 'enabled', 'disabled'],
       description : 'install the systemd-sysupdated service')

option('coredump', type : 'boolean',
       description : 'install the coredump handler')
option('pstore', type : 'boolean',
       description : 'install the pstore archival tool')
option('oomd', type : 'boolean',
       description : 'install the userspace oom killer')
option('logind', type : 'boolean',
       description : 'install the systemd-logind stack')
option('hostnamed', type : 'boolean',
       description : 'install the systemd-hostnamed stack')
option('localed', type : 'boolean',
       description : 'install the systemd-localed stack')
option('machined', type : 'boolean',
       description : 'install the systemd-machined stack')
option('portabled', type : 'boolean',
       description : 'install the systemd-portabled stack')
option('sysext', type : 'boolean',
       description : 'install the systemd-sysext stack')
option('mountfsd', type : 'boolean',
       description : 'install the systemd-mountfsd stack')
option('userdb', type : 'boolean',
       description : 'install the systemd-userdbd stack')
option('homed', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'install the systemd-homed stack')
option('networkd', type : 'boolean',
       description : 'install the systemd-networkd stack')
option('default-network', type : 'boolean', value : false,
       description : 'install default .network files')
option('timedated', type : 'boolean',
       description : 'install the systemd-timedated daemon')
option('timesyncd', type : 'boolean',
       description : 'install the systemd-timesyncd daemon')
option('remote', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'support for "journal over the network"')
option('create-log-dirs', type : 'boolean',
       description : 'create /var/log/journal{,/remote}')
option('nsresourced', type : 'boolean',
       description : 'install the systemd-nsresourced stack')
option('nss-myhostname', type : 'boolean',
       description : 'install nss-myhostname module')
option('nss-mymachines', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'install nss-mymachines module')
option('nss-resolve', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'install nss-resolve module')
option('nss-systemd', type : 'boolean',
       description : 'install nss-systemd module')
option('firstboot', type : 'boolean',
       description : 'support for firstboot mechanism')
option('randomseed', type : 'boolean',
       description : 'support for restoring random seed')
option('backlight', type : 'boolean',
       description : 'support for restoring backlight state')
option('vconsole', type : 'boolean',
       description : 'support for vconsole configuration')
option('vmspawn', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'install the systemd-vmspawn tool')
option('quotacheck', type : 'boolean',
       description : 'support for the quotacheck tools')
option('sysusers', type : 'boolean',
       description : 'support for the sysusers configuration')
option('storagetm', type : 'boolean',
       description : 'support for Storage Target Mode')
option('tmpfiles', type : 'boolean',
       description : 'support for tmpfiles.d')
option('importd', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       description : 'install the systemd-importd daemon')
option('hwdb', type : 'boolean',
       description : 'support for the hardware database')
option('rfkill', type : 'boolean',
       description : 'support for the rfkill tools')
option('xdg-autostart', type : 'boolean',
       description : 'install the xdg-autostart-generator and unit')
option('nspawn', type : 'feature',
       description : 'build and install systemd-nspawn')
option('man', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       value : 'disabled',
       description : 'build and install man pages')
option('html', type : 'feature', deprecated : { 'true' : 'enabled', 'false' : 'disabled' },
       value : 'disabled',
       description : 'build and install html pages')
option('translations', type : 'boolean', value : true,
       description : 'build and install translations')

option('certificate-root', type : 'string', value : '/etc/ssl',
       description : 'the prefix for TLS certificates')
option('dbuspolicydir', type : 'string',
       description : 'D-Bus policy directory')
option('dbussessionservicedir', type : 'string',
       description : 'D-Bus session service directory')
option('dbussystemservicedir', type : 'string',
       description : 'D-Bus system service directory')
option('dbus-interfaces-dir', type : 'string',
       description : 'export D-Bus introspection XML as standalone files')
option('default-timeout-sec', type : 'integer', value : 90,
       description : 'default timeout for system unit start/stop')
option('default-user-timeout-sec', type : 'integer', value : 90,
       description : 'default timeout for user unit start/stop')
option('pkgconfigdatadir', type : 'string', value : '',
       description : 'directory for arch-independent pkg-config files')
option('pkgconfiglibdir', type : 'string', value : '',
       description : 'directory for standard pkg-config files')
option('xinitrcdir', type : 'string', value : '',
       description : 'directory for xinitrc files')
option('rpmmacrosdir', type : 'string', value : 'lib/rpm/macros.d',
       description : 'directory for rpm macros ["no" disables]')
option('update-helper-user-timeout-sec', type : 'integer', value : 15,
       description : 'timeout for user manager package operations')
option('pamlibdir', type : 'string',
       description : 'directory for PAM modules')
option('pamconfdir', type : 'string',
       description : 'directory for PAM configuration ["no" disables]')
option('sshconfdir', type : 'string',

=== debian/changelog ===
systemd (258.1-2) unstable; urgency=medium

  [ Luca Boccassi ]
  * Backport patch to fix autopkgtest with new util-linux due to file move
    (Closes: #1118360)
  * getty-static: add missing Documentation=
  * systemd-tests: drop unused overrides

  [ Simon McVittie ]
  * d/libnss-systemd.postinst: Ensure module is enabled for all four
    databases. Before version 251.3-2, libnss-systemd was only enabled for
    the passwd and group databases. Since that version, new installations
    are set up in all four user/group databases (passwd, group, shadow and
    gshadow) but older installations' configuration remained unchanged
    until now. This resulted in configuration drift: shadow and gshadow
    would list systemd dynamic users in new installations of Debian 12 or
    13, but not in installations that had been upgraded from Debian 11 or
    older, preventing new versions of gdm3 from working on those older
    systems. Address this by doing a one-time migration from the old to
    new configuration. (Closes: #1118640)

 -- Luca Boccassi <bluca@debian.org>  Mon, 27 Oct 2025 13:06:14 +0000

systemd (258.1-1) unstable; urgency=medium

  * Override Lintian warning for groff-message. These manpages are
    generated by docbook, so these warnings are not useful.
  * Override Lintian warning for spare-manual-page
  * Override lintian warnings for conflicts-with-version
  * Drop versioned conflicts added for bullseye upgrades
  * Override Lintian warning for appstream-metadata-missing-modalias-
    provide
  * systemd: recommend login package (Closes: #1116286)
  * Explicitly disable bpf-framework for stage1 builds
  * autopkgest: install bsdutils and bsdextrautils for unit tests
  * Update upstream source from tag 'upstream/258.1' Update to upstream
    version '258.1' with Debian dir
    7941c0a45113f1d3faf0a067f15a8e11a7be2774
  * Make /run/lock world writable by default:
    "The TC therefore resolves that systemd shall provide /var/lock with
     relaxed enough permissions that existing Debian software that uses
     /var/lock for system-wide locks of serial devices (and similar
     purposes) works again. The TC exercises its power under constitution
     #6.1.4 to overrule the systemd maintainers in this regard."
    (Closes: #1110980)

 -- Luca Boccassi <bluca@debian.org>  Mon, 13 Oct 2025 16:34:55 +0100

=== debian/control ===
Source: systemd
Section: admin
Priority: optional
Maintainer: Debian systemd Maintainers <pkg-systemd-maintainers@lists.alioth.debian.org>
Uploaders: Marco d'Itri <md@linux.it>,
           Sjoerd Simons <sjoerd@debian.org>,
           Martin Pitt <mpitt@debian.org>,
           Felipe Sateler <fsateler@debian.org>,
           Luca Boccassi <bluca@debian.org>,
           Nick Rosbrook <enr0n@ubuntu.com>,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/systemd-team/systemd.git
Vcs-Browser: https://salsa.debian.org/systemd-team/systemd
Homepage: https://systemd.io
Build-Depends: debhelper-compat (= 13),
               debhelper (>= 13.11.6),
               dh-exec,
               dh-package-notes,
               dh-sequence-dlopenlibdeps <!stage1>,
               dh-sequence-installnss,
               dh-sequence-installsysusers,
               pkgconf,
               xsltproc <!nodoc>,
               docbook-xsl <!nodoc>,
               docbook-xml <!nodoc>,
               meson (>= 0.60.0),
               rsync | meson (>= 1.3.0~),
               clang:native [amd64 arm64 ppc64el riscv64 s390x] <!pkg.systemd.nobpf !stage1>,
               linux-bpf-dev [amd64 arm64 ppc64el riscv64 s390x] <!pkg.systemd.nobpf !stage1>,
               libbpf-dev [amd64 arm64 ppc64el riscv64 s390x] <!pkg.systemd.nobpf !stage1>,
               bpftool:native [amd64 arm64 ppc64el riscv64 s390x] <!pkg.systemd.nobpf !stage1 !pkg.systemd.upstream>,
               linux-tools-generic <pkg.systemd.upstream> | bpftool <pkg.systemd.upstream>,
               gettext,
               gperf,
               libcap-dev,
               libcrypt-dev,
               libpam0g-dev,
               libapparmor-dev (>= 2.13) <!stage1>,
               libidn2-dev <!stage1>,
               libiptc-dev <!stage1>,
               libaudit-dev <!stage1>,
               libdbus-1-dev (>= 1.3.2) <!nocheck> <!noinsttest>,
               libcryptsetup-dev (>= 2:2.4) <!stage1>,
               libselinux1-dev (>= 2.1.9),
               libacl1-dev,
               liblzma-dev,
               liblz4-dev (>= 1.3.0),
               lz4 <!nocheck>,
               libbz2-dev <!stage1>,
               zlib1g-dev <!stage1> | libz-dev <!stage1>,
               libcurl4-openssl-dev <!stage1>,
               libmicrohttpd-dev <!stage1>,
               libpcre2-dev <!stage1>,
               libgcrypt20-dev,
               libkmod-dev (>= 15),
               libblkid-dev (>= 2.24),
               libmount-dev (>= 2.30),
               libfdisk-dev (>= 2.33),
               libseccomp-dev (>= 2.3.1) [amd64 arm64 armel armhf i386 hppa loong64 mips mipsel mips64 mips64el x32 powerpc ppc64 ppc64el riscv64 s390x],
               libdw-dev (>= 0.158) <!stage1>,
               libpolkit-gobject-1-dev <!stage1>,
               libzstd-dev (>= 1.4.0),
               libtss2-dev <!stage1>,
               libfido2-dev <!stage1>,
               libp11-kit-dev <!stage1>,
               libssl-dev <!stage1>,
               libqrencode-dev <!stage1>,
               libxen-dev [amd64 arm64] <!stage1>,
               libpwquality-dev <!stage1>,
               libarchive-dev <!stage1>,
               linux-base <!nocheck>,
               acl <!nocheck>,
               python3:native,
               python3-jinja2:native,
               python3-lxml:native,
               python3-pefile:native <!stage1 !nocheck> <!stage1 !noinsttest>,
               python3-pyelftools [amd64 i386 arm64 armhf loong64 riscv64] <!stage1>,
               jq [amd64 arm64] <!stage1>,
               python3-pyparsing <!nocheck>,
               python3-evdev:native <!nocheck>,
               tzdata-legacy <!nocheck> | tzdata (<< 2025a-2) <!nocheck>,
               libcap2-bin <!nocheck>,
               iproute2 <!nocheck>,
               zstd <!nocheck>,
               gawk <!nocheck>,
               fdisk <!nocheck>,

Package: systemd
Architecture: linux-any
Multi-Arch: foreign
Priority: important
Recommends: default-dbus-system-bus | dbus-system-bus,
            linux-sysctl-defaults,
            login,
            systemd-timesyncd | time-daemon,
            systemd-cryptsetup,
            ${dlopen:Recommends},
Suggests: systemd-container,
          systemd-homed,
          systemd-userdbd,
          systemd-boot,
          systemd-resolved,
          systemd-repart,
          libtss2-tcti-device0,
          polkitd,
          ${dlopen:Suggests},
Pre-Depends: ${shlibs:Pre-Depends},
             ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsystemd0 (= ${binary:Version}),
         mount,
Conflicts: consolekit,
           libpam-ck-connector,
           systemd-shim,
           elogind,
           systemctl,
           opensysusers (<< 0.7.3-4.1~),
Breaks: less (<< 563),
        sicherboot (<< 0.1.6),
        dracut-core (<< 102-2~),
Provides: systemd-sysusers (= ${binary:Version}),
          systemd-tmpfiles (= ${binary:Version}),
Description: system and service manager
 systemd is a system and service manager for Linux. It provides aggressive
 parallelization capabilities, uses socket and D-Bus activation for starting
 services, offers on-demand starting of daemons, keeps track of processes using
 Linux control groups, maintains mount and automount points and implements an
 elaborate transactional dependency-based service control logic.
 .
 Installing the systemd package will not switch your init system unless you
 boot with init=/lib/systemd/systemd or install systemd-sysv in addition.

Package: systemd-sysv
Architecture: linux-any
Multi-Arch: foreign
Priority: important
Protected: yes
Conflicts: sysvinit-core,
           finit-sysv,
           runit-init,
           file-rc,
           systemd-shim,
           initscripts,
           orphan-sysvinit-scripts,
           sysv-rc,
           insserv,
           startpar,
           bfh-container (<< 20211009-22~),
           molly-guard (<< 0.8.2~),
Replaces: sysvinit-core,
Pre-Depends: systemd
Depends: ${misc:Depends},
         systemd (= ${binary:Version}),
Recommends: libpam-systemd,
            libnss-systemd
Description: system and service manager - SysV compatibility symlinks
 This package provides manual pages and compatibility symlinks needed for
 systemd to replace sysvinit.
 .
 Installing systemd-sysv will overwrite /sbin/init with a symlink to systemd.

Package: systemd-container
Build-Profiles: <!stage1>
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd,
         default-dbus-system-bus | dbus-system-bus
Recommends: libnss-mymachines,
            ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Conflicts: systemd (<< 256-2~),
Description: systemd container/nspawn tools
 This package provides systemd's tools for nspawn and container/VM management:
  * systemd-nspawn
  * systemd-machined and machinectl
  * systemd-importd
  * systemd-portabled and portablectl

Package: systemd-journal-remote
Build-Profiles: <!stage1>
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd,
Recommends: ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Description: tools for sending and receiving remote journal logs
 This package provides tools for sending and receiving remote journal logs:
  * systemd-journal-remote
  * systemd-journal-upload
  * systemd-journal-gatewayd

Package: systemd-coredump
Build-Profiles: <!stage1>
Architecture: linux-any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd
Recommends: ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Conflicts: core-dump-handler
Replaces: core-dump-handler
Provides: core-dump-handler
Description: tools for storing and retrieving coredumps
 This package provides systemd tools for storing and retrieving coredumps:
  * systemd-coredump
  * coredumpctl

Package: systemd-timesyncd
Architecture: linux-any
Multi-Arch: foreign
Priority: standard
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd
Recommends: ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Conflicts: time-daemon,
           systemd (<< 256.2-2~),
Replaces: time-daemon
Provides: time-daemon
Description: minimalistic service to synchronize local time with NTP servers
 The package contains the systemd-timesyncd system service that may be used to
 synchronize the local system clock with a remote Network Time Protocol server.

Package: systemd-tests
Architecture: linux-any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd (= ${binary:Version}),
         python3,
         python3-psutil,
Recommends: ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Build-Profiles: <!noinsttest>
Description: tests for systemd
 This package contains the test binaries. Those binaries are primarily used
 for autopkgtest and not meant to be installed on regular user systems.

Package: libpam-systemd
Architecture: linux-any
Multi-Arch: same
Priority: standard
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd (= ${binary:Version}),
         libpam-runtime,
         default-dbus-system-bus | dbus-system-bus,
         systemd-sysv
Recommends: dbus-user-session,
            ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Provides: logind (= ${binary:Version}), default-logind (= ${binary:Version})
Conflicts: libpam-elogind-compat,
Description: system and service manager - PAM module
 This package contains the PAM module which registers user sessions in
 the systemd control group hierarchy for logind.
 .
 If in doubt, do install this package.
 .
 Packages that depend on logind functionality need to depend on libpam-systemd.

Package: libnss-myhostname
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
Recommends: ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Description: nss module providing fallback resolution for the current hostname
 This package contains a plugin for the Name Service Switch, providing host
 name resolution for the locally configured system hostname as returned by
 gethostname(2). It returns all locally configured public IP addresses or -- if
 none are configured, the IPv4 address 127.0.0.2 (which is on the local
 loopback) and the IPv6 address ::1 (which is the local host).
 .
 A lot of software relies on that the local host name is resolvable. This
 package provides an alternative to the fragile and error-prone manual editing
 of /etc/hosts.
 .
 Installing this package automatically adds myhostname to /etc/nsswitch.conf.

Package: libnss-mymachines
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd-container (= ${binary:Version}),
Recommends: ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Description: nss module to resolve hostnames for local container instances
 nss-mymachines is a plugin for the GNU Name Service Switch (NSS) functionality
 of the GNU C Library (glibc) providing hostname resolution for local containers
 that are registered with systemd-machined.service(8). The container names are
 resolved to IP addresses of the specific container, ordered by their scope.
 .
 Installing this package automatically adds mymachines to /etc/nsswitch.conf.

Package: libnss-resolve
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd-resolved (= ${binary:Version}),
Recommends: ${dlopen:Recommends},
Suggests: ${dlopen:Suggests},
Description: nss module to resolve names via systemd-resolved
 nss-resolve is a plugin for the GNU Name Service Switch (NSS) functionality
 of the GNU C Library (glibc) providing DNS and LLMNR resolution to programs via
 the systemd-resolved daemon (provided in the systemd-resolved package).
 .

=== debian/rules ===
#! /usr/bin/make -f

#export DH_VERBOSE = 1
#export DEB_BUILD_OPTIONS = nostrip

export LC_ALL = C.UTF-8

include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

ifeq (amd64,$(DEB_HOST_ARCH))
export TEMPLATE_EFI_ARCH=x64
else ifeq (arm64,$(DEB_HOST_ARCH))
export TEMPLATE_EFI_ARCH=aa64
endif

# We are building on OBS? Then it's an upstream build, set the profile and
# use the addon for Secure Boot EFI signing
ifneq ("$(wildcard /.build/build.dist)","")
export DEB_BUILD_PROFILES += pkg.systemd.upstream
DH_ADDONS = --with=signobs
endif

ifeq ($(DEB_VENDOR),Ubuntu)
    DEFAULT_NTP_SERVERS = ntp.ubuntu.com
    SUPPORT_URL = http://www.ubuntu.com/support
    CONFFLAGS_DISTRO = \
		-Duser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin \
		-Ddefault-llmnr=no \
		-Ddefault-mdns=no

else
    DEFAULT_NTP_SERVERS = 0.debian.pool.ntp.org 1.debian.pool.ntp.org 2.debian.pool.ntp.org 3.debian.pool.ntp.org
    SUPPORT_URL = https://www.debian.org/support
    CONFFLAGS_DISTRO =
endif

TEST_TIMEOUT_MULTIPLIER = "-t 10"

# Fail on missing files and symbol changes on distro builds, but not if we
# build/test upstream master. Also, don't put the debian revision in the version
# tag when we build/test upstream as it doesn't have any meaning in that case
# and it allows using the current date as the debian revision without causing
# unnecessary rebuilds all the time.
ifeq (, $(filter pkg.systemd.upstream, $(DEB_BUILD_PROFILES)))
    DH_MISSING ?= --fail-missing
    GENSYMBOLS_LEVEL ?= 4
    VERSION_TAG = $(DEB_VERSION)
else
    DH_MISSING ?= --list-missing
    GENSYMBOLS_LEVEL ?= 1
    VERSION_TAG = $(DEB_VERSION_UPSTREAM)
endif

# Make sure that DEB_BUILD_OPTIONS can be used by users to override any options
# we set here (By default DEB_BUILD_MAINT_OPTIONS overrides DEB_BUILD_OPTIONS).
export DEB_BUILD_MAINT_OPTIONS = optimize=+lto hardening=+pie $(DEB_BUILD_OPTIONS)

CONFFLAGS = \
	-Dstatic-libsystemd=true \
	-Dversion-tag="$(VERSION_TAG)" \
	-Dquotaon-path=/usr/sbin/quotaon \
	-Dquotacheck-path=/usr/sbin/quotacheck \
	-Dkmod-path=/usr/bin/kmod \
	-Dkexec-path=/usr/sbin/kexec \
	-Dsulogin-path=/usr/sbin/sulogin \
	-Dmount-path=/usr/bin/mount \
	-Dumount-path=/usr/bin/umount \
	-Dloadkeys-path=/usr/bin/loadkeys \
	-Dsetfont-path=/usr/bin/setfont \
	-Dnologin-path=/usr/sbin/nologin \
	-Dsysvinit-path=/etc/init.d \
	-Dsysvrcnd-path=/etc \
	-Dlocalegen-path=/usr/sbin/locale-gen \
	-Ddebug-shell=/usr/bin/bash \
	-Dzshcompletiondir=/usr/share/zsh/vendor-completions \
	-Ddbuspolicydir=/usr/share/dbus-1/system.d/ \
	-Dsupport-url=$(SUPPORT_URL) \
	-Ddefault-kill-user-processes=false \
	-Ddefault-dnssec=no \
	-Dpamconfdir=no \
	-Dpamlibdir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
	-Drpmmacrosdir=no \
	-Dvconsole=false \
	-Dfirstboot=true \
	-Dxkbcommon=disabled \
	-Dwheel-group=false \
	-Doomd=true \
	-Durlify=true \
	-Dgnutls=disabled \
	-Dntp-servers="$(DEFAULT_NTP_SERVERS)" \
	-Dsystem-uid-max=999 \
	-Dsystem-gid-max=999 \
	-Dnobody-user=nobody \
	-Dnobody-group=nogroup \
	-Ddev-kvm-mode=0660 \
	-Dgroup-render-mode=0660 \
	-Drepart=enabled \
	-Dfdisk=enabled \
	-Dsysext=true \
	-Dselinux=enabled \
	-Dhwdb=true \
	-Dsysusers=true \
	-Dinstall-tests=$(if $(filter noinsttest,$(DEB_BUILD_PROFILES)),false,true) \
	-Dman=$(if $(filter nodoc,$(DEB_BUILD_PROFILES)),disabled,enabled) \
	-Ddbus-interfaces-dir=$(if $(filter nodoc,$(DEB_BUILD_PROFILES)),no,yes) \
	-Dtranslations=true \
	-Dnss-myhostname=true \
	-Dnss-mymachines=enabled \
	-Dnss-resolve=enabled \
	-Dnss-systemd=true \
	-Dresolve=true \
	-Dstatus-unit-format-default=combined \
	-Dstandalone-binaries=true \
	-Dutmp=false \
	-Dtty-mode=0600 \
	-Dvmspawn=enabled \
	-Dmode=$(if $(filter pkg.systemd.upstream,$(DEB_BUILD_PROFILES)),developer,release)

ifeq ($(filter nocheck,$(DEB_BUILD_PROFILES))$(filter noinsttest,$(DEB_BUILD_PROFILES)),nochecknoinsttest)
CONFFLAGS += -Dtests=false
else
CONFFLAGS += -Dtests=true
endif

ifeq (, $(filter stage1, $(DEB_BUILD_PROFILES)))
CONFFLAGS += \
	-Daudit=enabled \
	-Dlibcryptsetup=enabled \
	-Dlibcryptsetup-plugins=enabled \
	-Dcoredump=true \
	-Delfutils=enabled \
	-Dapparmor=enabled \
	-Dlibidn2=enabled \
	-Dlibiptc=enabled \
	-Dlibcurl=enabled \
	-Dimportd=enabled \
	-Dmicrohttpd=enabled \
	-Dopenssl=enabled \
	-Dcryptolib=openssl \
	-Ddns-over-tls=openssl \
	-Dlibfido2=enabled \
	-Dtpm2=enabled \
	-Dp11kit=enabled \
	-Dqrencode=enabled \
	-Dpwquality=enabled \
	-Dhomed=enabled \
	-Duserdb=true \
	-Dpcre2=enabled \
	-Dukify=enabled \
	-Dbootloader=$(if $(filter amd64 i386 arm64 armhf loong64 riscv64,$(DEB_HOST_ARCH)),enabled,disabled) \
	-Dsysupdate=enabled
else
CONFFLAGS += \
	-Daudit=disabled \
	-Dlibcryptsetup=disabled \
	-Dlibcryptsetup-plugins=disabled \
	-Dcoredump=false \
	-Delfutils=disabled \
	-Dapparmor=disabled \
	-Dlibidn2=disabled \
	-Dlibiptc=disabled \
	-Dlibcurl=disabled \
	-Dimportd=disabled \
	-Dmicrohttpd=disabled \
	-Dopenssl=disabled \
	-Dlibfido2=disabled \
	-Dtpm2=disabled \
	-Dp11kit=disabled \
	-Dqrencode=disabled \
	-Dpwquality=disabled \
	-Dhomed=disabled \
	-Duserdb=false \
	-Dpcre2=disabled \
	-Dukify=disabled \
	-Dbootloader=disabled \
	-Dbpf-framework=disabled \
	-Dsysupdate=disabled
endif

# BPF/BTF are only enabled and usable on a few architectures
ifeq (, $(filter $(DEB_BUILD_PROFILES), stage1 pkg.systemd.nobpf))
ifneq (,$(filter $(DEB_TARGET_ARCH), amd64 arm64 ppc64el riscv64 s390x))
CONFFLAGS += \
	-Dvmlinux-h=provided \
	-Dvmlinux-h-path=/usr/include/$(DEB_HOST_MULTIARCH)/linux/bpf/vmlinux.h \
	-Dbpf-framework=enabled \
	-Dbpf-compiler=clang

ifeq ($(DEB_VENDOR),Ubuntu)
# TODO: drop this and the alternative build dep once support for Noble is dropped
#
# Source: https://git.launchpad.net/ubuntu/+source/xdp-tools/tree/debian/rules
# On Ubuntu, the `bpftool` in path is a shell wrapper pointing at
# the binary corresponding to runtime kernel version.
#
# We do not know the kernel version being used on the system building
# this package, and in sbuild/container environments uname might not
# even match anything available to the build.
# Gladly for the build we only need the tool to generate skeleton code.
#
# If any /usr/lib/linux-tools/*/bpftool exists, locate the most recent
# version and point to that, otherwise `bpftool` from PATH will be
# used.
#
# Newer versions of linux-tools-* ship the binaries in /usr/lib/linux-tools-$(uname -r).
# Check there too.
bpftool_binary := $(shell find /usr/lib/linux-tools/ /usr/lib/linux-tools-* -name 'bpftool' -perm /u=x 2>/dev/null | sort -r | head -n1)
ifneq ($(bpftool_binary),)
export PATH := $(shell dirname $(bpftool_binary)):$(PATH)
endif
endif
endif
endif

ifeq (, $(filter pkg.systemd.upstream, $(DEB_BUILD_PROFILES)))
CONFFLAGS += -Ddns-servers=''
CONFFLAGS += -Dsbat-distro-url=https://tracker.debian.org/pkg/systemd
else
CONFFLAGS += --buildtype=debugoptimized
CONFFLAGS += -Dsbat-distro-url=https://github.com/systemd/systemd
CONFFLAGS += -Dsbat-distro=upstream
CONFFLAGS += -Dsbat-distro-summary='Upstream build from git'
endif

# Increase the minimum number of sections to keep free in stub PE header in
# order to be able to create an UKI file with many DTBs (each of them is stored
# in a different .dtbauto section)
ifneq (,$(filter $(DEB_TARGET_ARCH), arm64 armhf riscv64))
CONFFLAGS += -Defi-stub-extra-sections=500
endif

override_dh_auto_configure:
	dh_auto_configure \
		-- $(CONFFLAGS) $(CONFFLAGS_DISTRO) $(CONFFLAGS_UPSTREAM)

execute_before_dh_auto_build:
	# blhc false positives: C++ fuzz test program, cc -E flags listing, PE-COFF EFI binaries
	@echo 'blhc: ignore-line-regexp: .* -o test-bus-vtable-cc.*'
	@echo 'blhc: ignore-line-regexp: .*cc -E.*'
	@echo 'blhc: ignore-line-regexp: .* -o src/boot/.*'
	@echo 'blhc: ignore-line-regexp: .* Compiling C object fuzz.*'

execute_before_dh_auto_clean:
ifneq (, $(filter pkg.systemd.upstream, $(DEB_BUILD_PROFILES)))
	debian/extra/checkout-upstream
endif

execute_before_dh_install:

=== debian/tests/control ===
Tests: timedated, hostnamed, localed-locale, localed-x11-keymap, logind
Depends: systemd,
  systemd-timesyncd,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
Restrictions: needs-root, allow-stderr, isolation-container, skippable

Tests: unit-config
Depends: systemd,
  systemd-dev,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
Restrictions: needs-root, allow-stderr

Tests: storage
Depends: systemd,
  systemd-cryptsetup,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
  cryptsetup-bin,
Restrictions: needs-root, isolation-machine

Tests: networkd-test.py
Tests-Directory: test
Depends: systemd,
  systemd-resolved,
  systemd-cryptsetup,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
  cryptsetup-bin,
  systemd-sysv,
  polkitd,
  netlabel-tools,
  dnsmasq-base
Restrictions: needs-root, isolation-container, breaks-testbed, skip-not-installable, skippable

Tests: build-login
Depends: systemd,
  systemd-cryptsetup,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
  cryptsetup-bin,
  systemd-sysv,
  polkitd,
  dnsmasq-base,
  build-essential,
  libsystemd-dev,
Restrictions: isolation-container

Tests: boot-and-services
Depends: systemd-sysv,
  systemd-container,
  systemd-coredump,
  systemd-dev,
  libpam-systemd,
  libdw-dev,
  libelf-dev,
  xserver-xorg-video-dummy,
  xserver-xorg,
  gdm3 [!s390x !riscv64 !armel !loong64],
  cron,
  network-manager,
  busybox-static,
  sysvinit-utils,
  rsyslog,
  apparmor,
  pkgconf,
  python3,
  python3-pefile,
  dhcpcd-base | dhcpcd5,
Restrictions: needs-root, isolation-container, allow-stderr

Tests: unit-tests
Depends: systemd-tests,
  libpam-systemd,
  libnss-myhostname,
  libnss-mymachines,
  libnss-resolve,
  libnss-systemd,
  udev,
  tree,
  perl,
  python3,
  python3-colorama,
  python3-pefile,
  xz-utils,
  libcap2-bin,
  iproute2,
  lz4,
  acl,
  iputils-ping,
  dbus-user-session,
  zstd,
  libtss2-dev,
  libfido2-dev,
  libdw-dev,
  libqrencode-dev,
  libpwquality-dev,
  libarchive-dev,
  libgcrypt20-dev,
  libcryptsetup-dev,
  tzdata-legacy | tzdata,
  dosfstools,
  bsdutils,
  bsdextrautils,
Restrictions: needs-root, isolation-container, skip-not-installable, skippable

Tests: boot-smoke
Depends: systemd-sysv,
  network-manager,
  gdm3 [!s390x !riscv64 !armel !loong64],
  xserver-xorg-video-dummy,
Restrictions: needs-root, isolation-container, allow-stderr

Tests: build-with-static-libsystemd
Depends: systemd,
  pkgconf,
  build-essential,
  libsystemd-dev,
  libcap-dev,

Tests: tests-in-lxd
Depends: systemd-tests,
  udev,
  libpam-systemd,
  autopkgtest,
  lsb-release,
  snapd,
  dnsmasq-base,
Restrictions: needs-root, allow-stderr, isolation-machine, breaks-testbed, skip-not-installable, skippable

# Dummy test so that changes to key packages trigger our autopkgtests on ci.debian.net

=== debian/watch ===
version=4
opts=uversionmangle=s/-rc/~rc/,filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/systemd-$1\.tar\.gz/ \
  https://github.com/systemd/systemd/tags .*/v?(\d\S*)\.tar\.gz
